
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "PerlGtkExt.h"
#include "PerlGnomeBonoboInt.h"

#include "GnomeBonoboDefs.h"

static int
pStartFn (GnomeProgressiveDataSink* psink, gpointer data) {
	AV * args = (AV*)data;
	HV * hash = (HV*)SvRV(*av_fetch(args, 0, 0));
	SV * handler = *hv_fetch(hash, "start", 5, 0);
	int i, result;
	dSP;

	ENTER;
	SAVETMPS;
	PUSHMARK(sp);
	for (i=1;i<=av_len(args);i++)
		XPUSHs(sv_2mortal(newSVsv(*av_fetch(args, i, 0))));
	PUTBACK;
	i = perl_call_sv(handler, G_SCALAR);
	SPAGAIN;
	if (i!=1)
		croak("handler failed");

	result = POPi;
	
	PUTBACK;
	FREETMPS;
	LEAVE;

	return result;
}

static int
pEndFn (GnomeProgressiveDataSink* psink, gpointer data) {
	return 0;
}

static int
pAddDataFn (GnomeProgressiveDataSink* psink, const GNOME_ProgressiveDataSink_iobuf *buffer, gpointer data) {
	return 0;
}

static int
pSetSizeFn (GnomeProgressiveDataSink* psink, const CORBA_long count, gpointer data) {
	return 0;
}


MODULE = Gnome::ProgressiveDataSink		PACKAGE = Gnome::ProgressiveDataSink		PREFIX = gnome_progressive_data_sink_

#ifdef GNOME_PROGRESSIVE_DATA_SINK

Gnome::ProgressiveDataSink
new (Class, handlers, ...)
	SV *	Class
	SV *	handlers
	CODE:
	{
		AV * args = newAV();
		/* FIXME: handlers is an hash table with the handlers as values
		   and 'start', 'end', 'add-data', 'set-size' as keys */
		RETVAL = GNOME_PROGRESSIVE_DATA_SINK(gnome_progressive_data_sink_new(
			pStartFn, pEndFn, pAddDataFn, pSetSizeFn, args));
	}
	OUTPUT:
	RETVAL

#endif

