
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "PerlGtkExt.h"
#include "PerlGnomePrintInt.h"

#include "GnomePrintDefs.h"

MODULE = Gnome::PrintContext		PACKAGE = Gnome::PrintContext		PREFIX = gnome_print_

#ifdef GNOME_PRINT_CONTEXT

Gnome::PrintContext
new (Class, printer)
	SV*	Class
	Gnome::Printer	printer
	CODE:
	RETVAL = GNOME_PRINT_CONTEXT(gnome_print_context_new(printer));
	OUTPUT:
	RETVAL

Gnome::PrintContext
gnome_print_context_new_with_paper_size (Class, printer, paper)
	SV*	Class
	Gnome::Printer	printer
	char*	paper
	CODE:
	RETVAL = GNOME_PRINT_CONTEXT(gnome_print_context_new_with_paper_size(printer, paper));
	OUTPUT:
	RETVAL

int
gnome_print_context_close (context)
	Gnome::PrintContext	context

int
gnome_print_newpath (context)
	Gnome::PrintContext	context

int
gnome_print_moveto (context, x, y)
	Gnome::PrintContext	context
	double	x
	double	y

int
gnome_print_lineto (context, x, y)
	Gnome::PrintContext	context
	double	x
	double	y

int
gnome_print_curveto (context, x1, y1, x2, y2, x3, y3)
	Gnome::PrintContext	context
	double	x1
	double	y1
	double	x2
	double	y2
	double	x3
	double	y3

int
gnome_print_closepath (context)
	Gnome::PrintContext	context

int
gnome_print_setrgbcolor (context, r, g, b)
	Gnome::PrintContext context
	double	r
	double	g
	double	b

int
gnome_print_fill (context)
	Gnome::PrintContext	context

int
gnome_print_eofill (context)
	Gnome::PrintContext	context

int
gnome_print_setlinewidth (context, width)
	Gnome::PrintContext	context
	double	width

int
gnome_print_setmiterlimit (context, limit)
	Gnome::PrintContext	context
	double	limit

int
gnome_print_setlinejoin (context, jointype)
	Gnome::PrintContext	context
	int	jointype

int
gnome_print_setlinecap (context, linecap)
	Gnome::PrintContext	context
	int	linecap

int
gnome_print_setdash (context, offset, ...)
	Gnome::PrintContext	context
	double	offset
	CODE:
	{
		double *dashes;
		int nd = items-2;
		int i;
		dashes = g_new0(double, nd);
		for(i=2; i < items; ++i) {
			dashes[i-2] = SvNV(ST(i));
		}
		RETVAL=gnome_print_setdash (context, nd, dashes, offset);	
	}
	OUTPUT:
	RETVAL

int
gnome_print_strokepath (context)
	Gnome::PrintContext	context

int
gnome_print_stroke (context)
	Gnome::PrintContext	context

int
gnome_print_setfont (context, font)
	Gnome::PrintContext	context
	Gnome::Font	font

int
gnome_print_show (context, text)
	Gnome::PrintContext	context
	char*	text

int
gnome_print_concat (context, d0, d1, d2, d3, d4, d5)
	Gnome::PrintContext	context
	double	d0
	double	d1
	double	d2
	double	d3
	double	d4
	double	d5
	ALIAS:
		Gnome::PrintContext::setmatrix = 1
	CODE:
	{
		double m[6];
		m[0] = d0; m[1] = d1; m[2] = d2;
		m[3] = d3; m[4] = d4; m[5] = d5;
		if (ix == 0)
			RETVAL = gnome_print_concat(context, m);
		else
			RETVAL = gnome_print_setmatrix(context, m);
	}
	OUTPUT:
	RETVAL

int
gnome_print_gsave (context)
	Gnome::PrintContext	context

int
gnome_print_grestore (context)
	Gnome::PrintContext	context

int
gnome_print_clip (context)
	Gnome::PrintContext	context

int
gnome_print_eoclip (context)
	Gnome::PrintContext	context

int
gnome_print_showpage (context)
	Gnome::PrintContext	context

int
gnome_print_beginpage (context, page_name)
	Gnome::PrintContext	context
	char*	page_name

int
gnome_print_setopacity (context, opacity)
	Gnome::PrintContext	context
	double	opacity

# missing gnome_print*image
# missing textline
# missing v/bpath

int
gnome_print_scale (context, sx, sy)
	Gnome::PrintContext	context
	double	sx
	double	sy

int
gnome_print_rotate (context, theta)
	Gnome::PrintContext	context
	double	theta

int
gnome_print_translate (context, x, y)
	Gnome::PrintContext	context
	double	x
	double	y

int
gnome_print_context_open_file (context, filename)
	Gnome::PrintContext	context
	char	*filename

int
gnome_print_context_write_file (context, data)
	Gnome::PrintContext	context
	SV *data
	CODE:
	{
		STRLEN len;
		char *buf = SvPV(data, len);
		RETVAL = gnome_print_context_write_file (context, buf, len);
	}
	OUTPUT:
	RETVAL

int
gnome_print_context_close_file (context)
	Gnome::PrintContext	context

#endif

